DEF VAR cRfConfigcode AS CHAR NO-UNDO.

DEF BUFFER b-wm-transport FOR wm-transport.
DEF BUFFER b-wm-rf-config FOR wm-rf-config.
DEF BUFFER b-wm-val_ord   FOR wm-val_ord.

DISABLE TRIGGERS FOR LOAD OF b-wm-transport.
DISABLE TRIGGERS FOR LOAD OF b-wm-rf-config.
DISABLE TRIGGERS FOR LOAD OF b-wm-val_ord.

DEF TEMP-TABLE tt-config NO-UNDO
         FIELD companycode    AS CHAR
         FIELD choicetreecode AS CHAR
         FIELD sequence       AS INT
         INDEX tt-config AS PRIMARY companycode choicetreecode.

FOR EACH wm-transport NO-LOCK WHERE wm-transport.choicetreecode <> "":

  DO TRANSACTION:
    FIND FIRST b-wm-rf-config WHERE
               b-wm-rf-config.companycode            = wm-transport.companycode
           AND b-wm-rf-config.choicetreecode         = wm-transport.choicetreecode        
           AND b-wm-rf-config.ind_entrepot_mandatory = wm-transport.ind_entrepot_mandatory
           AND b-wm-rf-config.ind_rfinput_calcref1   = wm-transport.ind_rfinput_calcref1  
           AND b-wm-rf-config.ind_rf_intake_select   = wm-transport.ind_rf_intake_select  
           AND b-wm-rf-config.ind_scan_cust_barcode  = (IF wm-transport.rf_barcode_scan = "OWN"      THEN FALSE ELSE TRUE)
           AND b-wm-rf-config.ind_scan_own_barcode   = (IF wm-transport.rf_barcode_scan = "CUSTOMER" THEN FALSE ELSE TRUE)
               NO-LOCK NO-ERROR. 
    IF NOT AVAIL b-wm-rf-config
    THEN DO:
      FIND wm-choicetree WHERE
           wm-choicetree.companycode    = wm-transport.companycode   
       AND wm-choicetree.choicetreecode = wm-transport.choicetreecode 
           NO-LOCK NO-ERROR.
      FIND tt-config WHERE
           tt-config.companycode    = wm-transport.companycode   
       AND tt-config.choicetreecode = cRfConfigcode
           NO-ERROR.
      IF NOT AVAIL tt-config
      THEN DO:
        CREATE tt-config .
        ASSIGN tt-config.companycode    = wm-transport.companycode       
               tt-config.choicetreecode = cRfConfigcode.          
      END.
      tt-config.sequence = tt-config.sequence + 1.
      cRfConfigcode = wm-transport.choicetreecode.
      IF LENGTH(cRfConfigcode) > 6 THEN cRfConfigcode = SUBSTRING(cRfConfigcode,1,6).
      cRfConfigcode = cRfConfigcode + "-" + STRING(tt-config.sequence,"999").
      
      DO WHILE CAN-FIND( wm-rf-config NO-LOCK WHERE
                        wm-rf-config.companycode  = wm-transport.companycode                                           
                    AND wm-rf-config.rfconfigcode = cRfConfigcode ) :
        tt-config.sequence = tt-config.sequence + 1.
        cRfConfigcode = wm-transport.choicetreecode.
        IF LENGTH(cRfConfigcode) > 6 THEN cRfConfigcode = SUBSTRING(cRfConfigcode,1,6).
        cRfConfigcode = cRfConfigcode + "-" + STRING(tt-config.sequence,"999").
      END.
      
      CREATE b-wm-rf-config.
      ASSIGN b-wm-rf-config.companycode            = wm-transport.companycode                                           
             b-wm-rf-config.rfconfigcode           = cRfConfigcode 
             b-wm-rf-config.des                    = "Auto created on " + STRING(TODAY,"99/99/9999")
             b-wm-rf-config.choicetreecode         = wm-transport.choicetreecode                                        
             b-wm-rf-config.ind_entrepot_mandatory = wm-transport.ind_entrepot_mandatory                                
             b-wm-rf-config.ind_rfinput_calcref1   = wm-transport.ind_rfinput_calcref1                                  
             b-wm-rf-config.ind_rf_intake_select   = wm-transport.ind_rf_intake_select                                  
             b-wm-rf-config.ind_scan_cust_barcode  = (IF wm-transport.rf_barcode_scan = "OWN"      THEN FALSE ELSE TRUE)
             b-wm-rf-config.ind_scan_own_barcode   = (IF wm-transport.rf_barcode_scan = "CUSTOMER" THEN FALSE ELSE TRUE)
             b-wm-rf-config.ean_cust_configcode    = (IF wm-transport.rf_barcode_scan <> "OWN" AND AVAIL wm-choicetree
                                                      THEN wm-choicetree.barcode_configcode ELSE "")
             b-wm-rf-config.ean_own_configcode     = (IF wm-transport.rf_barcode_scan =  "OWN" AND AVAIL wm-choicetree
                                                      THEN wm-choicetree.barcode_configcode ELSE "")
             .
    END.
    FIND b-wm-transport EXCLUSIVE WHERE ROWID(b-wm-transport) = ROWID(wm-transport).
    b-wm-transport.rfconfigcode = b-wm-rf-config.rfconfigcode.
  END.
END.


FOR EACH wm-val_ord NO-LOCK WHERE wm-val_ord.choicetreecode <> "":

  DO TRANSACTION:
    FIND FIRST b-wm-rf-config WHERE
               b-wm-rf-config.companycode            = wm-val_ord.companycode
           AND b-wm-rf-config.choicetreecode         = wm-val_ord.choicetreecode        
           AND b-wm-rf-config.ind_entrepot_mandatory = FALSE
           AND b-wm-rf-config.ind_rfinput_calcref1   = wm-val_ord.ind_rfinput_calcref1  
           AND b-wm-rf-config.ind_rf_intake_select   = FALSE
           AND b-wm-rf-config.ind_scan_cust_barcode  = FALSE
           AND b-wm-rf-config.ind_scan_own_barcode   = TRUE
               NO-LOCK NO-ERROR. 
    IF NOT AVAIL b-wm-rf-config
    THEN DO:
      FIND wm-choicetree WHERE
           wm-choicetree.companycode    = wm-val_ord.companycode   
       AND wm-choicetree.choicetreecode = wm-val_ord.choicetreecode 
           NO-LOCK NO-ERROR.
      FIND tt-config WHERE
           tt-config.companycode    = wm-val_ord.companycode   
       AND tt-config.choicetreecode = cRfConfigcode
           NO-ERROR.
      IF NOT AVAIL tt-config
      THEN DO:
        CREATE tt-config .
        ASSIGN tt-config.companycode    = wm-val_ord.companycode       
               tt-config.choicetreecode = cRfConfigcode.          
      END.
      
      tt-config.sequence = tt-config.sequence + 1.
      cRfConfigcode = wm-val_ord.choicetreecode.
      IF LENGTH(cRfConfigcode) > 6 THEN cRfConfigcode = SUBSTRING(cRfConfigcode,1,6).
      cRfConfigcode = cRfConfigcode + "-" + STRING(tt-config.sequence,"999").
      
      DO WHILE CAN-FIND(wm-rf-config NO-LOCK WHERE
                        wm-rf-config.companycode  = wm-val_ord.companycode                                           
                    AND wm-rf-config.rfconfigcode = cRfConfigcode ) :
        tt-config.sequence = tt-config.sequence + 1.
        cRfConfigcode = wm-val_ord.choicetreecode.
        IF LENGTH(cRfConfigcode) > 6 THEN cRfConfigcode = SUBSTRING(cRfConfigcode,1,6).
        cRfConfigcode = cRfConfigcode + "-" + STRING(tt-config.sequence,"999").
      END.
      
      CREATE b-wm-rf-config.
      ASSIGN b-wm-rf-config.companycode            = wm-val_ord.companycode                                           
             b-wm-rf-config.rfconfigcode           = cRfConfigcode 
             b-wm-rf-config.des                    = "Auto created on " + STRING(TODAY,"99/99/9999")
             b-wm-rf-config.choicetreecode         = wm-val_ord.choicetreecode                                        
             b-wm-rf-config.ind_entrepot_mandatory = FALSE                                
             b-wm-rf-config.ind_rfinput_calcref1   = wm-val_ord.ind_rfinput_calcref1                                  
             b-wm-rf-config.ind_rf_intake_select   = FALSE
             b-wm-rf-config.ind_scan_cust_barcode  = FALSE
             b-wm-rf-config.ind_scan_own_barcode   = TRUE
             b-wm-rf-config.ean_cust_configcode    = ""
             b-wm-rf-config.ean_own_configcode     = ""
             .
    END.
    FIND b-wm-val_ord EXCLUSIVE WHERE ROWID(b-wm-val_ord) = ROWID(wm-val_ord).
    b-wm-val_ord.rfconfigcode = b-wm-rf-config.rfconfigcode.
  END.
END.
