{system/conversion/conversion_progress.i}

DEF VAR cProgram                      AS CHARACTER NO-UNDO.
DEF VAR cAction                       AS CHARACTER NO-UNDO.
DEF VAR cTable                        AS CHARACTER NO-UNDO.
DEF VAR iTotal                        AS INTEGER   NO-UNDO.
DEF VAR iDone                         AS INTEGER   NO-UNDO.

ASSIGN cProgram = THIS-PROCEDURE:FILE-NAME
       cAction  = "wm-activity per company"
       iTotal   = 0
       iDone    = 0
       cTable   = "wm-activity".

DEF BUFFER b-aa-costcode      FOR aa-costcode.
DEF BUFFER b-wm-activity      FOR wm-activity.
DEF BUFFER b-wm-activitygroup FOR wm-activitygroup.

DISABLE TRIGGERS FOR LOAD OF b-aa-costcode.
DISABLE TRIGGERS FOR LOAD OF b-wm-activity.
DISABLE TRIGGERS FOR LOAD OF b-wm-activitygroup.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

blok:
DO TRANSACTION ON ERROR UNDO blok, LEAVE blok:
  
  FOR EACH wm-activity NO-LOCK WHERE
           wm-activity.companycode   = ""
           ON ERROR UNDO blok, LEAVE blok:
    FOR EACH wm-parameter NO-LOCK  
             ON ERROR UNDO blok, LEAVE blok:
      CREATE b-wm-activity.
      BUFFER-COPY wm-activity
               TO b-wm-activity
           ASSIGN b-wm-activity.companycode = wm-parameter.companycode.
      FIND b-aa-costcode WHERE
           b-aa-costcode.companycode = b-wm-activity.companycode
       AND b-aa-costcode.costcode    = b-wm-activity.activitycode
           EXCLUSIVE NO-ERROR.
      IF NOT AVAIL b-aa-costcode 
      THEN DO:
        CREATE b-aa-costcode.
        ASSIGN b-aa-costcode.companycode     = b-wm-activity.companycode
               b-aa-costcode.costcode        = b-wm-activity.activitycode
               b-aa-costcode.des             = b-wm-activity.des
               b-aa-costcode.ind_prostore    = TRUE
               b-aa-costcode.vat_countrycode = b-wm-activity.vat_countrycode
               b-aa-costcode.vatcode         = b-wm-activity.vatcode        .
        b-wm-activity.costcode = b-wm-activity.activitycode.       
      END.
      ELSE DO:
        IF b-wm-activity.costcode = b-wm-activity.activitycode
        THEN DO:
          ASSIGN b-aa-costcode.ind_prostore    = TRUE
                 b-wm-activity.vat_countrycode = b-aa-costcode.vat_countrycode
                 b-wm-activity.vatcode         = b-aa-costcode.vatcode        .
        END.
      END.
    END.
    iDone = iDone + 1.
    RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END. 
  
  FOR EACH b-wm-activity EXCLUSIVE WHERE
           b-wm-activity.companycode   = ""
           ON ERROR UNDO blok, LEAVE blok:
    DELETE b-wm-activity.       
  END.
  
  ASSIGN cAction  = "wm-activitygroup per company"
         iTotal   = 0
         iDone    = 0
         cTable   = "wm-activitygroup".
  FOR EACH wm-activitygroup NO-LOCK WHERE
           wm-activitygroup.companycode   = ""
           ON ERROR UNDO blok, LEAVE blok:
    FOR EACH wm-parameter NO-LOCK
             ON ERROR UNDO blok, LEAVE blok:
      CREATE b-wm-activitygroup.
      BUFFER-COPY wm-activitygroup
               TO b-wm-activitygroup
           ASSIGN b-wm-activitygroup.companycode = wm-parameter.companycode.
    END.
    iDone = iDone + 1.
    RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END. 
  FOR EACH b-wm-activitygroup EXCLUSIVE WHERE
           b-wm-activitygroup.companycode   = ""
           ON ERROR UNDO blok, LEAVE blok:
    DELETE b-wm-activitygroup.       
  END.

END.



