{system/conversion/conversion_progress.i}

DEF VAR cProgram                      AS CHARACTER NO-UNDO.
DEF VAR cAction                       AS CHARACTER NO-UNDO.
DEF VAR cTable                        AS CHARACTER NO-UNDO.
DEF VAR iTotal                        AS INTEGER   NO-UNDO.
DEF VAR iDone                         AS INTEGER   NO-UNDO.
DEF VAR iModulo                       AS INTEGER   NO-UNDO.

ASSIGN cProgram = THIS-PROCEDURE:FILE-NAME
       cAction  = "Imo"
       iTotal   = 0
       iDone    = 0
	   iModulo  = 5000
       cTable   = "wm all tables".

DEF VAR iSeqnr AS INT NO-UNDO.

DEF BUFFER b-sp-sequence FOR sp-sequence.
DISABLE TRIGGERS FOR LOAD OF b-sp-sequence.

DEF BUFFER b-aa-imo FOR aa-imo.
DISABLE TRIGGERS FOR LOAD OF b-aa-imo.

DEF BUFFER b-wm-in_line FOR wm-in_line.
DISABLE TRIGGERS FOR LOAD OF b-wm-in_line.

DEF BUFFER b-wm-release FOR wm-release.
DISABLE TRIGGERS FOR LOAD OF b-wm-release.

DEF BUFFER b-wm-stock FOR wm-stock.
DISABLE TRIGGERS FOR LOAD OF b-wm-stock.

DEF BUFFER b-wm-product FOR wm-product.
DISABLE TRIGGERS FOR LOAD OF b-wm-product.

DEF BUFFER b-wm-address_product FOR wm-address_product.
DISABLE TRIGGERS FOR LOAD OF b-wm-address_product.

DEF BUFFER b-wm-edi-map FOR wm-edi-map.
DISABLE TRIGGERS FOR LOAD OF b-wm-edi-map.

DEF BUFFER b-wm-edi-sender-codes FOR wm-edi-sender-codes.
DISABLE TRIGGERS FOR LOAD OF b-wm-edi-sender-codes.

DEF BUFFER b-wm-edi-cust-codes FOR wm-edi-cust-codes.
DISABLE TRIGGERS FOR LOAD OF b-wm-edi-cust-codes.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

/* bepalen sequence */
FIND b-sp-sequence WHERE
     b-sp-sequence.sequencecode = "aa-imo.imo_seqnr"
     EXCLUSIVE NO-ERROR.
IF NOT AVAIL b-sp-sequence 
THEN DO TRANSACTION:
  CREATE b-sp-sequence.
  ASSIGN b-sp-sequence.sequencecode   = "aa-imo.imo_seqnr"
         b-sp-sequence.current_value  = 1
         b-sp-sequence.cycle_at_limit = YES
         b-sp-sequence.des            = ""
         b-sp-sequence.interval       = 1
         b-sp-sequence.limit          = 2147483647
         b-sp-sequence.previous_value = 0.
END.
iSeqnr = b-sp-sequence.current_value.

FOR EACH wm-imo:
  FIND b-aa-imo WHERE
       b-aa-imo.imocode = wm-imo.imocode
       NO-LOCK NO-ERROR.
  IF NOT AVAIL b-aa-imo
  THEN DO TRANSACTION:
    CREATE b-aa-imo.
    ASSIGN b-aa-imo.imo_seqnr    = iSeqnr
           b-aa-imo.imocode      = wm-imo.imocode
           b-aa-imo.des          = wm-imo.des
           b-aa-imo.IMDG-number  = wm-imo.IMDG-class
           b-aa-imo.unno         = wm-imo.UNnr
           b-aa-imo.ind_inactive = wm-imo.ind_inactive
           b-aa-imo.attachmentnr = NEXT-VALUE(aa-attachment).
    iSeqnr = iSeqnr + 1.       
    iDone = iDone + 1.
    IF iDone MODULO iModulo = 0
    THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END.
  FOR EACH sp-company NO-LOCK :
    /* update in_lines */
    FOR EACH wm-in_line NO-LOCK WHERE
             wm-in_line.companycode = sp-company.companycode
         AND wm-in_line.imocode     = wm-imo.imocode
             USE-INDEX imocode: 
      DO TRANSACTION:
        FIND b-wm-in_line EXCLUSIVE WHERE ROWID(b-wm-in_line) = ROWID(wm-in_line).
        b-wm-in_line.imo_seqnr = b-aa-imo.imo_seqnr.
        iDone = iDone + 1.
        IF iDone MODULO iModulo = 0
		THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
      END.
      /* update position of in_line */
      FOR EACH wm-release NO-LOCK WHERE
               wm-release.companycode = sp-company.companycode
           AND wm-release.IN_ordnr    = wm-in_line.IN_ordnr
           AND wm-release.IN_linenr   = wm-in_line.IN_linenr
           AND wm-release.imocode     = wm-imo.imocode
               USE-INDEX IN_ordnr: 
        DO TRANSACTION:
          FIND b-wm-release EXCLUSIVE WHERE ROWID(b-wm-release) = ROWID(wm-release).
          b-wm-release.imo_seqnr = b-aa-imo.imo_seqnr.
          iDone = iDone + 1.
          IF iDone MODULO iModulo = 0
		  THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
        END.
      END.
    END.
    /* update stock */
    FOR EACH wm-stock NO-LOCK WHERE
             wm-stock.companycode = sp-company.companycode
         AND wm-stock.imocode     = wm-imo.imocode
             USE-INDEX imocode: 
      DO TRANSACTION:
        FIND b-wm-stock EXCLUSIVE WHERE ROWID(b-wm-stock) = ROWID(wm-stock).
        b-wm-stock.imo_seqnr = b-aa-imo.imo_seqnr.
        iDone = iDone + 1.
        IF iDone MODULO iModulo = 0
        THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
      END.
    END.
    /* update customer product */
    FOR EACH wm-address_product NO-LOCK WHERE
             wm-address_product.companycode = sp-company.companycode
         AND wm-address_product.imocode     = wm-imo.imocode:
      DO TRANSACTION:
        FIND b-wm-address_product EXCLUSIVE WHERE ROWID(b-wm-address_product) = ROWID(wm-address_product).
        b-wm-address_product.imo_seqnr = b-aa-imo.imo_seqnr.
        iDone = iDone + 1.
        IF iDone MODULO iModulo = 0
        THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
      END.
    END.
  END.
  /* update product */
  FOR EACH wm-product NO-LOCK WHERE
           wm-product.imocode = wm-imo.imocode:
    DO TRANSACTION:
      FIND b-wm-product EXCLUSIVE WHERE ROWID(b-wm-product) = ROWID(wm-product).
      b-wm-product.imo_seqnr = b-aa-imo.imo_seqnr.
      iDone = iDone + 1.
      IF iDone MODULO iModulo = 0
      THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
    END.
  END.
END.

/* update edi layout field map */
FOR EACH wm-edi-map NO-LOCK WHERE
         wm-edi-map.fieldname_wm = 'imocode':
  DO TRANSACTION:
    FIND b-wm-edi-map EXCLUSIVE WHERE ROWID(b-wm-edi-map) = ROWID(wm-edi-map).
    b-wm-edi-map.fieldname_wm = 'imo_seqnr'.
    iDone = iDone + 1.
    IF iDone MODULO iModulo = 0
    THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END.
END.

/* update edi sender code map */
FOR EACH wm-edi-sender-codes NO-LOCK WHERE
         wm-edi-sender-codes.xref_table = 'wm-imo':
  DO TRANSACTION:
    FIND b-wm-edi-sender-codes EXCLUSIVE WHERE ROWID(b-wm-edi-sender-codes) = ROWID(wm-edi-sender-codes).
    FIND aa-imo WHERE
         aa-imo.imocode = b-wm-edi-sender-codes.xref_value
         NO-LOCK NO-ERROR.
    IF AVAIL aa-imo 
    THEN DO:
      ASSIGN b-wm-edi-sender-codes.xref_table = 'aa-imo'
             b-wm-edi-sender-codes.xref_value = STRING(aa-imo.imo_seqnr,"99999999").
      iDone = iDone + 1.
      IF iDone MODULO iModulo = 0
      THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
    END.
  END.
END.

/* update edi customer code map */
FOR EACH wm-edi-cust-codes NO-LOCK WHERE
         wm-edi-cust-codes.xref_table = 'wm-imo':
  DO TRANSACTION:
    FIND b-wm-edi-cust-codes EXCLUSIVE WHERE ROWID(b-wm-edi-cust-codes) = ROWID(wm-edi-cust-codes).
    FIND aa-imo WHERE
         aa-imo.imocode = b-wm-edi-cust-codes.xref_value
         NO-LOCK NO-ERROR.
    IF AVAIL aa-imo 
    THEN DO:
      ASSIGN b-wm-edi-cust-codes.xref_table = 'aa-imo'
             b-wm-edi-cust-codes.xref_value = STRING(aa-imo.imo_seqnr,"99999999").
      iDone = iDone + 1.
      IF iDone MODULO iModulo = 0
      THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
    END.
  END.
END.

/* update sequence */
DO TRANSACTION:
  ASSIGN b-sp-sequence.current_value  = iSeqnr
         b-sp-sequence.previous_value = iSeqnr - 1.
END. 

