{system/conversion/conversion_progress.i}

DEF VAR cProgram                      AS CHARACTER NO-UNDO.
DEF VAR cAction                       AS CHARACTER NO-UNDO.
DEF VAR cTable                        AS CHARACTER NO-UNDO.
DEF VAR iTotal                        AS INTEGER   NO-UNDO.
DEF VAR iDone                         AS INTEGER   NO-UNDO.
DEF VAR cTerminalCode                 AS CHARACTER NO-UNDO.
DEF VAR lIntake                       AS LOGICAL   NO-UNDO.
DEF VAR lOuttake                      AS LOGICAL   NO-UNDO.
DEF VAR lVisitor                      AS LOGICAL   NO-UNDO.
DEF VAR cOrderTypecode                AS CHARACTER NO-UNDO.

ASSIGN cProgram = THIS-PROCEDURE:FILE-NAME
       cAction  = "Visit"
       iTotal   = 0
       iDone    = 0
       cTable   = "wm-visit".

DISABLE TRIGGERS FOR LOAD OF wm-visit.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

FOR EACH wm-visit EXCLUSIVE-LOCK:

  cOrderTypecode = "".
  lVisitor       = FALSE.
  lIntake        = FALSE.
  lOuttake       = FALSE.

  FOR EACH wm-visit_item NO-LOCK WHERE wm-visit_item.companycode = wm-visit.companycode
                                   AND wm-visit_item.visit_seqnr = wm-visit.visit_seqnr BY wm-visit_item.visit_item_seqnr.
    IF cOrderTypecode = ""
    THEN cOrderTypecode = wm-visit_item.order_typecode.
    CASE wm-visit_item.order_typecode:
      WHEN "VISITOR" THEN lVisitor = TRUE.
      WHEN "INTAKE"  THEN lIntake  = TRUE.
      WHEN "OUTTAKE" THEN lOuttake = TRUE.
    END CASE.

/*    IF wm-visit.loc_gatecode = "" THEN wm-visit.loc_gatecode = wm-visit_item.loc_gatecode.*/
  END.

  IF lVisitor THEN cOrderTypecode = "VISITOR".
  ELSE
  DO.
    IF lIntake AND lOuttake THEN cOrderTypecode = "INTAKE-OUTTAKE".
    ELSE IF lIntake  THEN cOrderTypecode = "INTAKE".
    ELSE IF lOuttake THEN cOrderTypecode = "OUTTAKE".
  END.
  wm-visit.order_typecode = cOrderTypecode.

  iDone = iDone + 1.
  IF iDone MODULO 100 = 0
  THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
