{System/conversion/conversion_progress.i}

DEFINE VARIABLE cProgram  AS CHARACTER NO-UNDO FORMAT "x(50)".
DEFINE VARIABLE cAction   AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE cTable    AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE iTotal    AS INTEGER   NO-UNDO.
DEFINE VARIABLE iDone     AS INTEGER   NO-UNDO.
DEFINE VARIABLE iTel      AS INTEGER   NO-UNDO.

DEFINE VARIABLE gcLijst                AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcCompanyCode          AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcBlock                AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcParameter            AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcDepOnGateOut         AS CHARACTER NO-UNDO.

/* ************************  Function Prototypes ********************** */
FUNCTION spGetEntry RETURNS CHARACTER 
  (INPUT pcLabel      AS CHAR,
   INPUT pcValueList  AS CHAR,
   INPUT pcSep1       AS CHAR,
   INPUT pcSep2       AS CHAR) FORWARD.
   
/* *********************** main block ********************************* */  
 
ASSIGN
  cProgram = THIS-PROCEDURE:FILE-NAME
  cAction  = "Counting parameter settings"
  cTable   = "wm-parameter"
  iTotal   = 0
  iDone    = 0.

DISABLE TRIGGERS FOR LOAD OF wm-parameter.
DISABLE TRIGGERS FOR DUMP OF wm-parameter.

DO TRANSACTION ON ERROR UNDO, LEAVE
               ON STOP  UNDO, LEAVE.  
  
  FIND sp-control WHERE sp-control.controlkode = "KBCP-1703-CONVERSION" EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAIL sp-control THEN RETURN.
  
  gcParameter = sp-control.lijst.
  gcCompanyCode  = spGetEntry("CompanyCode"          , gcParameter, ",", "=").
  gcBlock        = spGetEntry("BlockOuttakeConfirmed", gcParameter, ",", "=").
  gcDepOnGateOut = spGetEntry("DepartedOnGateOut"    , gcParameter, ",", "=").
 
  FIND wm-parameter WHERE wm-parameter.companycode = gcCompanyCode EXCLUSIVE-LOCK.
  wm-parameter.ind_block_confirmed_till_gateout = LOGICAL(gcBlock) NO-ERROR.
  wm-parameter.ind_depart_on_gateout            = LOGICAL(gcDepOnGateOut) NO-ERROR.
         
  iTel  = iTel + 1.
  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END.   

/* **********************  Internal Procedures  *********************** */


/* ************************  Function Implementations ***************** */

FUNCTION spGetEntry RETURNS CHARACTER 
  ( INPUT pcLabel      AS CHAR,
      INPUT pcValueList  AS CHAR,
      INPUT pcSep1       AS CHAR,
      INPUT pcSep2       AS CHAR ):
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/  
    DEF VAR cValue AS CHAR NO-UNDO.
    DEF VAR iTel   AS INT  NO-UNDO.
    DEF VAR iPos   AS INT  NO-UNDO.

    ASSIGN pcValuelist = REPLACE(pcValuelist,pcSep2,pcSep1).
      
    iPos = LOOKUP (pcLabel,pcValueList,pcSep1).

    IF iPos MODULO 2 <> 0 /* dan is het een label , anders een waarde */  
    THEN DO:
     cValue = ENTRY(iPos + 1, pcValueList,pcSep1).
    END. /* IF */
    ELSE DO:
      SEARCHBLOCK:
      DO iTel = 1 TO NUM-ENTRIES(pcValueList,pcSep1) BY 2:
         IF ENTRY(iTel, pcValueList,pcSep1)  = pcLabel
         THEN DO: 
           cValue = ENTRY(iTel + 1, pcValueList,pcSep1).
           LEAVE SEARCHBLOCK. 
         END.
      END. /* DO */       
    END. /* ELSE */ 

 RETURN cValue.   /* Function return value. */

    
END FUNCTION.

