&IF defined(DEBUG) > 0 &THEN
  PROCEDURE displayProgress.
    DEF INPUT PARAM pcProgram AS CHAR NO-UNDO.
    DEF INPUT PARAM pcAction  AS CHAR NO-UNDO.
    DEF INPUT PARAM pcTable   AS CHAR NO-UNDO.
    DEF INPUT PARAM piTotal   AS INT  NO-UNDO.
    DEF INPUT PARAM piDone    AS INT  NO-UNDO.
  END PROCEDURE.
&ELSE
 {System/conversion/conversion_progress.i}
&ENDIF

DEFINE VARIABLE cProgram       AS CHARACTER NO-UNDO FORMAT "x(50)".
DEFINE VARIABLE cAction        AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE cTable         AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE iTotal         AS INTEGER   NO-UNDO.
DEFINE VARIABLE iDone          AS INTEGER   NO-UNDO.
DEFINE VARIABLE iTel           AS INTEGER   NO-UNDO.
DEFINE VARIABLE iNr            AS INTEGER   NO-UNDO.
DEFINE VARIABLE iPropNr        AS INTEGER   NO-UNDO.
DEFINE VARIABLE iPropNrStart   AS INTEGER   NO-UNDO.
DEFINE VARIABLE iPropNrEnd     AS INTEGER   NO-UNDO.
DEFINE VARIABLE lPropListFound AS LOGICAL   NO-UNDO.

DEF VAR sp-companycode AS CHAR NO-UNDO.
  
DEF BUFFER b-wm-fieldprop FOR wm-fieldprop.
DEF BUFFER b-wm-parameter FOR wm-parameter.
  
DISABLE TRIGGERS FOR LOAD OF b-wm-fieldprop          .
DISABLE TRIGGERS FOR LOAD OF b-wm-parameter          .

/* ************************  Function Prototypes ********************** */

    
/* *********************** main block ********************************* */  
 
ASSIGN
  cProgram = THIS-PROCEDURE:FILE-NAME
  cAction  = "Convert field properties"
  cTable   = "wm-fieldprop"
  iTotal   = 0
  iDone    = 0.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

propnr-loop:
DO iNr = 9 TO 1 BY -1.
  iPropNrStart   = iNr * 100.
  iPropNrEnd     = iPropNrStart + 99.
  
  REPEAT.
    lPropListFound = TRUE.
    DO iPropNr = iPropNrStart TO iPropNrStart + 4.
      FIND b-wm-fieldprop WHERE b-wm-fieldprop.fieldpropnr = iPropNr NO-LOCK NO-ERROR.
      IF AVAIL b-wm-fieldprop THEN lPropListFound = FALSE.
    END.
    IF lPropListFound THEN LEAVE propnr-loop.
    iPropNrStart = iPropNrStart + 5.
    IF iPropNrStart + 5 > iPropNrEnd THEN LEAVE.  
  END.
END.

IF lPropListFound THEN 
DO TRANSACTION. 
  iPropNrEnd = iPropNrStart + 4.
  iTotal     = 5.
  iNr        = 0.
  DO iPropNr = iPropNrStart TO iPropNrEnd.
    iNr = iNr + 1.
    CREATE b-wm-fieldprop.
    ASSIGN b-wm-fieldprop.fieldpropnr        = iPropNr
           b-wm-fieldprop.fieldpropset       = "VISIT"
           b-wm-fieldprop.des                = SUBSTITUTE("Visit info &1", iNr)
           b-wm-fieldprop.field_label        = b-wm-fieldprop.des
           b-wm-fieldprop.field_format       = "X(15)"
           b-wm-fieldprop.field_datatypecode = "CHARACTER"
           b-wm-fieldprop.field_shortlabel   = SUBSTITUTE("VIS&1", iNr)
           b-wm-fieldprop.xref_type          = "".
    iDone = iDone + 1.
    RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  
  iTotal = 0.
  iDone  = 0.
  FOR EACH b-wm-parameter EXCLUSIVE-LOCK.
    ASSIGN b-wm-parameter.visit_info1_propnr = iPropNrStart
           b-wm-parameter.visit_info2_propnr = iPropNrStart + 1
           b-wm-parameter.visit_info3_propnr = iPropNrStart + 2 
           b-wm-parameter.visit_info4_propnr = iPropNrStart + 3
           b-wm-parameter.visit_info5_propnr = iPropNrStart + 4.
    iDone = iDone + 1.
    RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END.
END.

  

/* **********************  Internal Procedures  *********************** */
