

&IF defined(DEBUG) > 0 &THEN
  PROCEDURE displayProgress.
    DEF INPUT PARAM pcProgram AS CHAR NO-UNDO.
    DEF INPUT PARAM pcAction  AS CHAR NO-UNDO.
    DEF INPUT PARAM pcTable   AS CHAR NO-UNDO.
    DEF INPUT PARAM piTotal   AS INT  NO-UNDO.
    DEF INPUT PARAM piDone    AS INT  NO-UNDO.
  END PROCEDURE.
&ELSE
 {System/conversion/conversion_progress.i}
&ENDIF

DEFINE VARIABLE cProgram   AS CHARACTER NO-UNDO FORMAT "x(50)".
DEFINE VARIABLE cAction    AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE cTable     AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE iTotal     AS INTEGER   NO-UNDO.
DEFINE VARIABLE iDone      AS INTEGER   NO-UNDO.
DEFINE VARIABLE iTel       AS INTEGER   NO-UNDO.

DEF VAR cNRTPCodes     AS CHAR NO-UNDO.
DEF VAR sp-companycode AS CHAR NO-UNDO.
  
DEF BUFFER b-wm-visit_action FOR wm-visit_action.
  
DISABLE TRIGGERS FOR LOAD OF b-wm-visit_action.

/* ************************  Function Prototypes ********************** */
    
FUNCTION wmGetGenericParameter RETURNS CHARACTER
   (INPUT pcCompanycode    AS CHAR, 
    INPUT pcParameterGroup AS CHAR,
    INPUT pcParameterName  AS CHAR) FORWARD.

    
/* *********************** main block ********************************* */  
 
ASSIGN
  cProgram = THIS-PROCEDURE:FILE-NAME
  cAction  = "Convert visit actions"
  cTable   = "wm-ssd"
  iTotal   = 0
  iDone    = 0.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

FOR EACH sp-company NO-LOCK.
  sp-companycode = sp-company.companycode.
  cNRTPCodes     = wmGetGenericParameter(?, "SSD", "NRTPVisitActionCodes").
  
  FOR EACH b-wm-visit_action WHERE b-wm-visit_action.companycode = sp-companycode EXCLUSIVE-LOCK.
    
    IF cNRTPCodes <> "" AND CAN-DO(cNRTPCodes, b-wm-visit_action.visit_actioncode) 
    THEN ASSIGN b-wm-visit_action.ind_keep_visit_id_active = TRUE
                b-wm-visit_action.ind_nrtp                 = TRUE.
     
    IF b-wm-visit_action.ind_keep_visit_id_active THEN 
    DO.
      b-wm-visit_action.ind_no_ticket   = TRUE.
      b-wm-visit_action.ind_no_gate_pin = TRUE.
      IF b-wm-visit_action.ind_nrtp THEN b-wm-visit_action.ind_report_to_service_desk = FALSE.
      ELSE b-wm-visit_action.ind_report_to_service_desk = TRUE.
    END.
    
    iTotal = iTotal + 1.                           
    iDone  = iDone + 1.
    RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END.
END.

/* **********************  Internal Procedures  *********************** */

/* ************************  Function Implementations ***************** */

FUNCTION wmGetGenericParameter RETURNS CHARACTER
   (INPUT pcCompanycode    AS CHAR, 
    INPUT pcParameterGroup AS CHAR,
    INPUT pcParameterName  AS CHAR):
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/  
  DEF VAR cValue       AS CHAR NO-UNDO.
  DEF VAR cCompanyCode AS CHAR NO-UNDO.
  
  cCompanyCode = pcCompanyCode.
  IF cCompanyCode = ? THEN cCompanyCode = sp-companycode.

  FIND wm-parameter_generic WHERE wm-parameter_generic.companycode     = cCompanyCode
                              AND wm-parameter_generic.parameter_group = pcParameterGroup
                              AND wm-parameter_generic.parameter_name  = pcParameterName NO-LOCK NO-ERROR.
  IF AVAIL wm-parameter_generic THEN
  DO.
    IF NOT wm-parameter_generic.ind_inactive THEN 
    DO.
      cValue = wm-parameter_generic.parameter_value.
      IF cValue EQ "" THEN cValue = wm-parameter_generic.parameter_initial_value.
    END.
  END.
    
  RETURN cValue.
      
END FUNCTION.


