
/*------------------------------------------------------------------------
    File        : wm-2101-after-01-wm-ssd_gac.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Wed Feb 14 11:34:00 CET 2018
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
&IF defined(DEBUG) > 0 &THEN
  PROCEDURE displayProgress.
    DEF INPUT PARAM pcProgram AS CHAR NO-UNDO.
    DEF INPUT PARAM pcAction  AS CHAR NO-UNDO.
    DEF INPUT PARAM pcTable   AS CHAR NO-UNDO.
    DEF INPUT PARAM piTotal   AS INT  NO-UNDO.
    DEF INPUT PARAM piDone    AS INT  NO-UNDO.
  END PROCEDURE.
&ELSE
 {System/conversion/conversion_progress.i}
&ENDIF

DEFINE VARIABLE cProgram   AS CHARACTER NO-UNDO FORMAT "x(50)".
DEFINE VARIABLE cAction    AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE cTable     AS CHARACTER NO-UNDO FORMAT "X(50)".
DEFINE VARIABLE iTotal     AS INTEGER   NO-UNDO.
DEFINE VARIABLE iDone      AS INTEGER   NO-UNDO.
DEFINE VARIABLE iTel       AS INTEGER   NO-UNDO.

DEF VAR cOldGacCode AS CHAR NO-UNDO.
DEF VAR cNewGacCode AS CHAR NO-UNDO.
DEF VAR iGacCounter AS INT  NO-UNDO.
DEF VAR iDacCounter AS INT  NO-UNDO.
DEF VAR lParree     AS LOG  NO-UNDO.
DEF VAR lPaxton     AS LOG  NO-UNDO.

/* ********************  Preprocessor Definitions  ******************** */


/* ***************************  Main Block  *************************** */
ASSIGN
  cProgram = THIS-PROCEDURE:FILE-NAME
  cAction  = "Convert gate access control systems"
  cTable   = "wm-ssd_gac"
  iTotal   = 0
  iDone    = 0.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
 
DEF BUFFER b-wm-ssd_gac FOR wm-ssd_gac.
DEF BUFFER b-wm-ssd     FOR wm-ssd.
  
DISABLE TRIGGERS FOR LOAD OF b-wm-ssd_gac.
DISABLE TRIGGERS FOR LOAD OF b-wm-ssd.
  
FOR EACH b-wm-ssd_gac EXCLUSIVE-LOCK.
  iTotal  = iTotal + 1.
  
  lParree = FALSE.
  lPaxton = FALSE.
  
  IF b-wm-ssd_gac.ssd_gaccode MATCHES "*paxton*" THEN lPaxton = TRUE.
  IF b-wm-ssd_gac.ssd_gaccode MATCHES "*parree*" THEN lParree = TRUE.
  
  IF lParree OR lPaxton THEN 
  DO.
    cOldGacCode = b-wm-ssd_gac.ssd_gaccode.
    CASE b-wm-ssd_gac.ssd_gactype.
      WHEN "GAC" THEN 
      DO.
        iGacCounter = iGacCounter + 1.
        cNewGacCode = IF lParree THEN "CARDACCESS" ELSE "NET2-GAC".
        IF iGacCounter > 1 THEN cNewGacCode = cNewGacCode + "-" + STRING(iGacCounter, "99"). 
      END.  
      WHEN "DAC" THEN 
      DO. 
        iDacCounter = iDacCounter + 1.
        cNewGacCode = IF lParree THEN "CARDACCESS" ELSE "NET2-DAC".
        IF iDacCounter > 1 THEN cNewGacCode = cNewGacCode + "-" + STRING(iDacCounter, "99").
      END.  
      OTHERWISE 
      DO.
        iGacCounter = iGacCounter + 1.
        cNewGacCode = IF lParree THEN "CARDACCESS" ELSE "NET2-GAC".
        IF iGacCounter > 1 THEN cNewGacCode = cNewGacCode + "-" + STRING(iGacCounter, "99").
        b-wm-ssd_gac.ssd_gactype = "GAC".
      END.
    END CASE.
    
    FOR EACH b-wm-ssd WHERE b-wm-ssd.ssd_gaccode = cOldGacCode EXCLUSIVE-LOCK.
      b-wm-ssd.ssd_gaccode = cNewGacCode. 
    END.
         
    b-wm-ssd_gac.ssd_gaccode = cNewGacCode. 
    
    iDone  = iDone + 1. 
  END.  
  
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END.