{system/conversion/conversion_progress.i}
DEF VAR cProgram                      AS CHARACTER NO-UNDO.
DEF VAR cAction                       AS CHARACTER NO-UNDO.
DEF VAR cTable                        AS CHARACTER NO-UNDO.
DEF VAR iTotal                        AS INTEGER   NO-UNDO.
DEF VAR iDone                         AS INTEGER   NO-UNDO.
DEF VAR cLocation                     AS CHARACTER NO-UNDO.
DEF VAR hNewBuf                       AS HANDLE    NO-UNDO.
DEF VAR cDbtKeys                      AS CHAR      NO-UNDO INIT "ssd_code,ssd_dialogue_code".
DEF VAR cDbtField                     AS CHAR      NO-UNDO INIT "ssd_des".

ASSIGN cProgram = THIS-PROCEDURE:FILE-NAME
       cAction  = "SSD dialogue sequence translations"
       iTotal   = 0
       iDone    = 0
       cTable   = "wm-ssd_dialogue_sequence".

DEF BUFFER b-wm-ssd_dialogue_sequence FOR wm-ssd_dialogue_sequence.

DISABLE TRIGGERS FOR LOAD OF b-wm-ssd_dialogue_sequence.
DISABLE TRIGGERS FOR LOAD OF sp-translation.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

FOR EACH b-wm-ssd_dialogue_sequence NO-LOCK.
  hNewBuf = BUFFER b-wm-ssd_dialogue_sequence:HANDLE.  
         
  RUN wmSetTranslations ( hNewBuf, cDbtKeys, cDbtField ).
         
  iDone  = iDone  + 1.
  iTotal = iTotal + 1.
  
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END. 

/* **********************  Internal Procedures  *********************** */

PROCEDURE wmSetTranslations:
/*------------------------------------------------------------------------------
 Purpose:
 Notes:
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER phBuffer   AS HANDLE NO-UNDO.
  DEF INPUT PARAMETER pcDbtKeys  AS CHAR   NO-UNDO.
  DEF INPUT PARAMETER pcDbtField AS CHAR   NO-UNDO.

  DEF VAR iDbtLanguageNr      AS INT    NO-UNDO.
  DEF VAR iDbtKey             AS INT    NO-UNDO.
  DEF VAR cDbtKey             AS CHAR   NO-UNDO.
  DEF VAR cDbtKeyList         AS CHAR   NO-UNDO.
  DEF VAR cDbtKeyField        AS CHAR   NO-UNDO.
  DEF VAR cDbtKeyValue        AS CHAR   NO-UNDO.
  DEF VAR cDbtProgramFunction AS CHAR   NO-UNDO.
  DEF VAR hDbtBuffer          AS HANDLE NO-UNDO.

  iDbtLanguageNr = 3.
  
  ASSIGN iDbtKey             = 0
         cDbtKeyField        = ""
         cDbtKeyValue        = ""
         cDbtKey             = ""
         cDbtKeyList         = pcDbtKeys
         cDbtProgramFunction = phBuffer:TABLE + "." + pcDbtField.
         
  DO iDbtKey = 1 TO NUM-ENTRIES(cDbtKeyList).
    cDbtKeyField = ENTRY(iDbtKey, cDbtKeyList).
    cDbtKeyValue = phBuffer:BUFFER-FIELD(cDbtKeyField):BUFFER-VALUE().
    cDbtKey = cDbtKey + ( IF cDbtKey EQ "" THEN "" ELSE CHR(3) ) + cDbtKeyValue.
  END.
  
  FIND sp-translation WHERE sp-translation.application      = "WM"
                        AND sp-translation.user_interface   = "DATABASE"
                        AND sp-translation.program_function = cDbtProgramFunction
                        AND sp-translation.languagenr       = iDbtLanguageNr
                        AND sp-translation.translate_key    = cDbtKey EXCLUSIVE-LOCK NO-WAIT NO-ERROR.
  IF NOT AVAIL sp-translation AND NOT LOCKED sp-translation THEN 
  DO.
    CREATE sp-translation.
    ASSIGN sp-translation.application      = "WM"
           sp-translation.user_interface   = "DATABASE"
           sp-translation.program_function = cDbtProgramFunction
           sp-translation.languagenr       = iDbtLanguageNr    
           sp-translation.translate_key    = cDbtKey
           sp-translation.dt_create        = TODAY
           sp-translation.create_usercode  = "SOFTPAK".
  END.
  ELSE IF AVAIL sp-translation THEN 
  DO.
    ASSIGN sp-translation.dt_update        = TODAY
           sp-translation.update_usercode  = "SOFTPAK".
  END. 
  IF AVAIL sp-translation THEN 
  DO. 
    IF INDEX(sp-translation.translated_value, CHR(10)) > 0 THEN sp-translation.ind_editor = TRUE.
    sp-translation.translated_value = phBuffer:BUFFER-FIELD(pcDbtField):BUFFER-VALUE.
  END.   

END PROCEDURE.
